package org.netkernel.http.rest;

import java.security.DigestOutputStream;
import java.security.MessageDigest;

import org.netkernel.http.util.MimeEtag;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.representation.IReadableBinaryStreamRepresentation;
import org.netkernel.layer0.util.NullOutputStream;
import org.netkernel.layer0.util.Utils;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;

public class EtagAccessor extends StandardAccessorImpl
{
	public EtagAccessor()
	{	this.declareThreadSafe();
		/*
		try
		{	MimeEtag.test();
		}
		catch(Exception e)
		{	e.printStackTrace();			
		}
		*/
	}

	@Override
	public void onSource(INKFRequestContext aContext) throws Exception
	{
		IReadableBinaryStreamRepresentation rbs=aContext.source("arg:operand", IReadableBinaryStreamRepresentation.class);
		String format=aContext.source("arg:operator", String.class);
		MessageDigest md = MessageDigest.getInstance(format);
		DigestOutputStream dos=new DigestOutputStream(new NullOutputStream(), md);
		rbs.write(dos);
		dos.flush();
		String hex=Utils.toHexString(md.digest());
		//Attempt to encode originating mime into Etag - this is a workaround
		//for a serious failure of the PATCH IETF specification!!!
		if(aContext.getThisRequest().argumentExists("mime"))
		{	String mime=aContext.source("arg:mime", String.class);
			try
			{	hex=MimeEtag.encode(mime, hex);
				//System.out.println(mime+" = "+hex);
			}
			catch(Exception e)
			{	aContext.logRaw(aContext.LEVEL_WARNING, "Non-ASCII characters in mimetype "+mime+" cannot encode for composite Etag so ommitting");				
			}
		}
		String eTag="\""+hex+"\"";
		//System.out.println("ETAG :"+ eTag);
		aContext.createResponseFrom(eTag);
	}
}
