package org.netkernel.http.transport;

import javax.servlet.http.Cookie;

import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.representation.IHDSNode;
import org.netkernel.layer0.representation.IReadableBinaryStreamRepresentation;
import org.netkernel.layer0.representation.impl.HDSBuilder;
import org.netkernel.module.standard.endpoint.StandardTransreptorImpl;

public class HTTPCookieParser extends StandardTransreptorImpl
{
	public HTTPCookieParser()
	{	this.declareThreadSafe();		
		this.declareFromRepresentation(IReadableBinaryStreamRepresentation.class);
		this.declareFromRepresentation(IHDSNode.class);
		this.declareToRepresentation(Cookie.class);
	}

	@Override
	public void onTransrept(INKFRequestContext context) throws Exception
	{
		IHDSNode n=context.sourcePrimary(IHDSNode.class);
		Cookie c=new Cookie((String)n.getFirstValue("//name"),(String)n.getFirstValue("//value"));
		String comment=(String)n.getFirstValue("//comment");
		if(comment !=null) c.setComment(comment);
		String domain=(String)n.getFirstValue("//domain");
		if(domain!=null)	c.setDomain(domain);
		Integer maxAge=(Integer)n.getFirstValue("//maxAge");
		if(maxAge!=null)	c.setMaxAge(maxAge);
		String path=(String)n.getFirstValue("//path");
		if(path!=null) c.setPath(path);
		Boolean secure=(Boolean)n.getFirstValue("//secure");
		if(secure!=null) c.setSecure(secure);
		Integer version=(Integer)n.getFirstValue("//version");
		if(version!=null) c.setVersion(version);
		
		context.createResponseFrom(c);
	}
	
}
