package org.netkernel.http.transport;

import javax.servlet.http.Cookie;

import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.representation.IHDSNode;
import org.netkernel.layer0.representation.IReadableBinaryStreamRepresentation;
import org.netkernel.layer0.representation.impl.HDSBuilder;
import org.netkernel.module.standard.endpoint.StandardTransreptorImpl;

public class HTTPCookieSerializer extends StandardTransreptorImpl
{
	public HTTPCookieSerializer()
	{	this.declareThreadSafe();		
		this.declareFromRepresentation(Cookie.class);
		this.declareToRepresentation(IReadableBinaryStreamRepresentation.class);
		this.declareToRepresentation(IHDSNode.class);
	}

	@Override
	public void onTransrept(INKFRequestContext context) throws Exception
	{
		Cookie c=context.sourcePrimary(Cookie.class);
		HDSBuilder b=new HDSBuilder();
		b.pushNode("hds");
		b.addNode("name", c.getName());
		b.addNode("value", c.getValue());
		b.addNode("comment", c.getComment());
		b.addNode("domain", c.getDomain());
		b.addNode("maxAge", c.getMaxAge());
		b.addNode("path", c.getPath());
		b.addNode("secure", c.getSecure());
		b.addNode("version", c.getVersion());
		
		IHDSNode n=b.getRoot();
		Object rep;
		if(context.getThisRequest().getRepresentationClass().isAssignableFrom(IHDSNode.class))
		{	rep=n;			
		}
		else
		{	rep=context.transrept(n, IReadableBinaryStreamRepresentation.class);
		}
		context.createResponseFrom(rep);
	}
	
}
