package org.netkernel.http.util;

import java.util.HashMap;
import java.util.Map;

import org.netkernel.layer0.util.Utils;



public class MimeEtag
{
	private static HashMap<String,String> mForwardCache=new HashMap();
	private static HashMap<String,String> mBackwardCache=new HashMap();
	
	public static String encode(String mime, String hash) throws Exception
	{	StringBuilder sb=new StringBuilder();
		String hex=mForwardCache.get(mime);
		if(hex==null)
		{	try
			{	XiaoMime xm=new XiaoMime();
				byte[] mimebytes=mime.getBytes();
				byte[] compressed=new byte[mimebytes.length];
				int length=xm.compress(mimebytes, compressed);
				byte[] truncated=new byte[length];
				System.arraycopy(compressed, 0, truncated, 0, length);
				hex=Utils.toHexString(truncated);
				mForwardCache.put(mime, hex);
				mBackwardCache.put(hex, mime);
			}
			catch(Exception e)
			{	e.printStackTrace();
				throw e;
			}
		}
		sb.append(hex).append("-").append(hash);
		return sb.toString();
	}
	
	public static Map<String,String> decode(String hash) throws Exception
	{	if(hash.indexOf("-")>0)
		{	String[] split=hash.split("-");
			String mime=mBackwardCache.get(split[0]);
			if(mime==null)
			{	byte[] bs=Utils.fromHexString(split[0]);
				XiaoMime x=new XiaoMime();
				byte[] out=new byte[1024];
				int length=x.decompress(bs, bs.length, out);
				byte[] f=new byte[length];
				for(int i=0; i<length; i++)
				{	f[i]=out[i];				
				}
				mime=new String(f);
			}
			HashMap<String,String> map=new HashMap();
			map.put("mime", mime);
			map.put("hash", split[1]);
			return map;
		}
		else throw new Exception("Not a composite mime-hash Etag");
	}
	
	public static void test() throws Exception
	{	
		String[] tests={
					"mary had a little lamb application/json",
					"application/vnd.thisiscompletelymadeup",
					"application/json",
		           "text/xml",
		           "text/plain",
		           "application/vnd.the quick brown fox jumped over the lazy dog",
		           "image/png"
		};
		for(String s: tests)
		{	String t=encode(s, "HASH");
			System.out.println(t + " DECODED "+decode(t).get("mime"));
		}
		
	}
	
}
